;===================================================================
; Protos.inc
;
;	This contains all of the prototypes that we need to use the
;	functions in this program.
;
;	Any procedure we define will have its prototype placed here.
;
;===================================================================

;#################################################################################
;#################################################################################
; THE PROTOTYPES
;#################################################################################
;#################################################################################
	
	;==================================
	; Main Program Procedures
	;==================================
	WinMain PROTO  		:DWORD,:DWORD,:DWORD,:DWORD
	WndProc PROTO  		:DWORD,:DWORD,:DWORD,:DWORD

	;===================================
	; Main Game procedures
	;===================================
	Game_Init PROTO
	Game_Main PROTO
	Game_Shutdown PROTO

	;=========================================
	; The DirectDraw Procedures 
	;=========================================
	DD_Init PROTO		:DWORD, :DWORD, :DWORD
	DD_ShutDown PROTO
	DD_Lock_Surface PROTO	:DWORD, :DWORD
	DD_Unlock_Surface PROTO	:DWORD
	DD_Create_Surface PROTO	:DWORD, :DWORD, :DWORD
	DD_Flip PROTO
	DD_Fill_Surface PROTO	:DWORD, :DWORD, :DWORD, :DWORD
	DD_GetDC PROTO		:DWORD
	DD_ReleaseDC PROTO	:DWORD, :DWORD
	DD_Draw_Text PROTO	:DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
	DD_Load_Bitmap PROTO	:DWORD, :DWORD, :DWORD, :DWORD, :DWORD
	DD_Get_RGB_Format PROTO	:DWORD
	DD_Select_Font PROTO	:DWORD, :DWORD, :DWORD, :DWORD, :DWORD
	DD_UnSelect_Font PROTO	:DWORD, :DWORD, :DWORD

	;========================================
	; The bitmap routines
	;========================================
	Create_From_SFP PROTO	:DWORD, :DWORD, :DWORD
	Draw_Bitmap PROTO	:DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD


	;=====================================
	; Direct Input Procedures
	;=====================================
	DI_Init PROTO
	DI_ShutDown PROTO
	DI_Init_Mouse PROTO
	DI_Init_Keyboard PROTO
	DI_Read_Mouse PROTO
	DI_Read_Keyboard PROTO

	;=====================================
	; Menu Procedures
	;=====================================
	Init_Menu PROTO
	Shutdown_Menu PROTO
	Process_Main_Menu PROTO
	Process_File_Menu PROTO

	;========================================
	; Our Timer routines
	;========================================
	Init_Time PROTO
	Start_Time PROTO	:DWORD
	Wait_Time PROTO		:DWORD, :DWORD
	Get_Time PROTO		
	Delay_Time PROTO	:DWORD

	;========================================
	; The shape routines
	;========================================
	Init_Shapes PROTO
	Shutdown_Shapes PROTO
	New_Game PROTO
	Init_Grid PROTO
	Draw_Shape PROTO	:BYTE
	Draw_Grid PROTO
	Draw_Captions PROTO
	Rotate_Shape PROTO
	Move_Shape PROTO	:DWORD
	Update_Shape PROTO
	New_Shape PROTO
	Place_In_Grid PROTO
	Test_Collision PROTO
	Test_Bounds PROTO
	Line_Test PROTO
	Adjust_Score PROTO	:DWORD
	Is_Game_Won PROTO
	
	;=====================================
	; Direct Sound Procedures
	;=====================================
	DS_Init PROTO
	DS_ShutDown PROTO
	Play_Sound PROTO	:DWORD, :DWORD
	Set_Sound_Volume PROTO	:DWORD, :DWORD
	Set_Sound_Freq PROTO	:DWORD, :DWORD
	Set_Sound_Pan PROTO	:DWORD, :DWORD
	Stop_Sound PROTO	:DWORD
	Stop_All_Sounds PROTO	
	Delete_Sound PROTO	:DWORD
	Delete_All_Sounds PROTO	
	Status_Sound PROTO	:DWORD
	Load_WAV PROTO		:DWORD, :DWORD

	;=====================================
	; Transition Procedures
	;=====================================
	Transition PROTO
	Wipe_Trans PROTO	:DWORD, :DWORD